/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.cg.transformer.vb;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import blanco.cg.valueobject.BlancoCgSourceFile;

/**
 * BlancoCgSourceFilêȂ importWJ܂B
 * 
 * ̃NXblancoCg̃o[IuWFNg\[XR[hgXtH[}[̌ʂ̓WJ@\łB<br>
 * importWJ͈ӊOɂGȏłB
 * 
 * @author IGA Tosiki
 */
class BlancoCgImportVbSourceExpander {
    /**
     * importWJ邽߂̃AJ[B
     */
    private static final String REPLACE_IMPORT_HERE = "/*replace import here*/";

    /**
     * ꂽAJ[̃CfbNXB
     * 
     * ̃NX̏̉ߒ importҏW܂A̓sx ̒lXV܂B
     */
    private int fFindReplaceImport = -1;

    /**
     * importWJ܂B
     * 
     * ̃\bh̓NXWJE\bhWJȂǈꎮIɌĂяo悤ɂ܂B
     * 
     * @param argSourceFile
     *            \[Xt@CCX^XB
     * @param argSourceLines
     *            \[XsC[WB(java.lang.Stringi[܂)
     */
    public void transformImport(final BlancoCgSourceFile argSourceFile,
            final List argSourceLines) {
        // importΏۂ̃NXI[ɕt^Ăz\܂B
        trimArraySuffix(argSourceFile.getImportList());

        // import(using)̃XgNX܂B
        trimClassName(argSourceFile);

        // ŏimport\[gďs₷܂B
        sortImport(argSourceFile.getImportList());

        // dimport܂B
        trimRepeatedImport(argSourceFile.getImportList());

        // importKv̂ȂNX܂
        trimUnnecessaryImport(argSourceFile.getImportList());

        // NXpbP[Wɑ΂import}܂B
        trimMyselfImport(argSourceFile, argSourceFile.getImportList());

        // AJ[܂B
        fFindReplaceImport = findAnchorString(argSourceLines);
        if (fFindReplaceImport < 0) {
            throw new IllegalArgumentException("import̒u𔭌邱Ƃł܂łB");
        }

        // ŏɁuSystemvpbP[WWJ܂B
        expandImportWithTarget(argSourceFile, "System", argSourceLines);

        // ŌɁuSystemvȊÕpbP[WWJ܂B
        expandImportWithTarget(argSourceFile, null, argSourceLines);

        // AJ[܂B
        removeAnchorString(argSourceLines);
    }

    /**
     * import(using)̃XgNX܂B
     * 
     * ́AC#.NETł͖OԒPʂusingwsłB<br>
     * ܂NXčc̏s܂B
     * 
     * @param argSourceFile
     *            \[Xt@CIuWFNgB
     */
    private void trimClassName(final BlancoCgSourceFile argSourceFile) {
        for (int index = 0; index < argSourceFile.getImportList().size(); index++) {
            String strImport = (String) argSourceFile.getImportList()
                    .get(index);
            final int findLastDot = strImport.lastIndexOf('.');
            if (findLastDot > 0) {
                strImport = strImport.substring(0, findLastDot);
            }
            argSourceFile.getImportList().set(index, strImport);
        }
    }

    /**
     * WJΏۂƂȂ^[QbgӎăC|[gWJ܂B
     * 
     * @param argSourceFile
     * @param argTarget
     *            java. ܂ javax. ܂ nullw肵܂B
     * @param argSourceLines
     *            \[XR[hsXgB
     */
    private void expandImportWithTarget(final BlancoCgSourceFile argSourceFile,
            final String argTarget, final List argSourceLines) {
        boolean isProcessed = false;
        for (int index = 0; index < argSourceFile.getImportList().size(); index++) {
            final Object objImport = argSourceFile.getImportList().get(index);
            if (objImport instanceof String == false) {
                throw new IllegalArgumentException("import̃Xg̒lłA["
                        + objImport + "]ł java.lang.StringȊǑ^["
                        + objImport.getClass().getName() + "]ɂȂĂ܂B");
            }

            final String strImport = (String) objImport;

            if (argTarget == null) {
                // System. ȊOWJ܂B
                if (strImport.startsWith("System")) {
                    // ΏۂƂpbP[WȊOł̂ŁAXLbv܂B
                    // System. ̓n[hR[hĂ_ɒӂĂB
                    continue;
                }
            } else {
                if (strImport.startsWith(argTarget) == false) {
                    // ΏۂƂpbP[WȊOł̂ŁAXLbv܂B
                    continue;
                }
            }

            isProcessed = true;
            argSourceLines.add(fFindReplaceImport++, "Imports " + strImport);
        }

        if (isProcessed) {
            // importWJ݂ꍇɂ̂݋󔒂t^܂B
            argSourceLines.add(fFindReplaceImport++, "");
        }
    }

    /**
     * uAJ[̍s(0IW)܂B
     * 
     * @return AJ[̈ʒu(0IW)BłȂꍇɂ-1B
     * @param argSourceLines
     *            \[XXgB
     */
    private static final int findAnchorString(final List argSourceLines) {
        for (int index = 0; index < argSourceLines.size(); index++) {
            final String line = (String) argSourceLines.get(index);
            if (line.equals(REPLACE_IMPORT_HERE)) {
                // ܂B
                return index;
            }
        }

        // ł܂łBłȂƂ -1 ߂܂B
        return -1;
    }

    /**
     * AJ[}܂B
     * 
     * ̌㔼ŃC|[gҐȂ܂A̍ۂɎQƂAJ[ǉĂ܂B<br>
     * ̃\bh͑̃NXĂяo܂B
     * 
     * @param argSourceLines
     *            \[XXgB
     */
    public static final void insertAnchorString(final List argSourceLines) {
        argSourceLines.add(BlancoCgImportVbSourceExpander.REPLACE_IMPORT_HERE);
    }

    /**
     * AJ[܂B
     * 
     * @param argSourceLines
     *            \[XXgB
     */
    private static final void removeAnchorString(final List argSourceLines) {
        // ŌɃAJ[񂻂̂̂B
        int findReplaceImport2 = findAnchorString(argSourceLines);
        if (findReplaceImport2 < 0) {
            throw new IllegalArgumentException("import̒u𔭌邱Ƃł܂łB");
        }
        argSourceLines.remove(findReplaceImport2);
    }

    /**
     * ^ꂽimport\[g܂B
     * 
     * z肳m[ȟ^(java.lang.String)ȊO^ƁAO܂B
     * 
     * @param argImport
     *            C|[gXgB
     */
    private static final void sortImport(final List argImport) {
        Collections.sort(argImport, new Comparator() {
            public int compare(final Object arg0, final Object arg1) {
                if (arg0 instanceof String == false) {
                    throw new IllegalArgumentException("import̃Xg̒lłA["
                            + arg0 + "]ł java.lang.StringȊǑ^["
                            + arg0.getClass().getName() + "]ɂȂĂ܂B");
                }
                if (arg1 instanceof String == false) {
                    throw new IllegalArgumentException("import̃Xg̒lłA["
                            + arg1 + "]ł java.lang.StringȊǑ^["
                            + arg1.getClass().getName() + "]ɂȂĂ܂B");
                }
                final String str0 = (String) arg0;
                final String str1 = (String) arg1;
                return str0.compareTo(str1);
            }
        });
    }

    /**
     * importΏۂ̃NXI[ɕt^Ăz\܂B
     * 
     * @param argImport
     *            C|[gXgB
     */
    private void trimArraySuffix(final List argImport) {
        for (int index = 0; index < argImport.size(); index++) {
            String strImport = (String) argImport.get(index);
            for (;;) {
                // z\ŏIĂJԂ܂B
                if (strImport.endsWith("[]")) {
                    strImport = strImport.substring(0, strImport.length() - 2);
                    argImport.set(index, strImport);
                } else {
                    break;
                }
            }
        }
    }

    /**
     * dsvimport܂B
     * 
     * ̃\bh́A^ꂽListɃ\[gς݂ł邱ƂOƂ܂B
     * 
     * @param argImport
     *            C|[gXgB
     */
    private void trimRepeatedImport(final List argImport) {
        // dimportB
        String pastImport = "";
        for (int index = argImport.size() - 1; index >= 0; index--) {
            final String strImport = (String) argImport.get(index);
            if (pastImport.equals(strImport)) {
                // ɏĂdimportłBsvȂ̂ł܂B
                argImport.remove(index);
            }
            // importOimportƂċL܂B
            pastImport = strImport;
        }
    }

    /**
     * importKv̂ȂNX܂B
     * 
     * ̓Iɂ java.lang  v~eBu^svƔfΏۂłB
     * 
     * @param argImport
     *            C|[gXgB
     */
    private void trimUnnecessaryImport(final List argImport) {
        // ܂̓v~eBu^܂B
        for (int index = argImport.size() - 1; index >= 0; index--) {
            // \[g_Ō^`FbN͎{ς݂łB
            final String strImport = (String) argImport.get(index);

            if (BlancoCgTypeVbSourceExpander
                    .isLanguageReservedKeyword(strImport)) {
                argImport.remove(index);
            }
        }
    }

    /**
     * gpbP[Wimport܂B
     * 
     * @param argSourceFile
     *            \[Xt@CCX^XB
     * @param argImport
     *            C|[gXgB
     */
    private void trimMyselfImport(final BlancoCgSourceFile argSourceFile,
            final List argImport) {
        trimSpecificPackage(argSourceFile.getPackage(), argImport);
    }

    /**
     * ̃pbP[WɂāAXg珜܂B
     * 
     * NXpbP[W̏ɗp܂B
     * 
     * @param argSpecificPackage
     *            ΏۂƂpbP[WB
     * @param argImport
     *            C|[g̃XgB
     */
    private static void trimSpecificPackage(final String argSpecificPackage,
            final List argImport) {
        for (int index = argImport.size() - 1; index >= 0; index--) {
            // \[g_Ō^`FbN͎{ς݂łB
            final String strImport = (String) argImport.get(index);

            // C#.NETł͖OԂi[Ă܂BOԓm𒼐ڔr܂B
            if (argSpecificPackage.equals(strImport)) {
                argImport.remove(index);
            }
        }
    }
}
